import OpenGL.*;

abstract class Body implements Drawable {
    protected Soul soul;

    public void setSoul(Soul soul){
        soul = soul;
    }

    public Soul getSoul(){
        return soul;
    }

    public void draw(OpenGLwidget gl){
        gl.pushMatrix();
        gl.translate(tx,ty,tz);
        gl.scale(scale, scale, scale);
        gl.rotate(rx, 1.f, 0.f, 0.f);
        gl.rotate(ry, 0.f, 1.f, 0.f);
        gl.rotate(rz, 0.f, 0.f, 1.f);
        drawBody(gl);
        gl.popMatrix();
    }

    abstract public void drawBody(OpenGLwidget gl);
     float tx;
     float ty;
     float tz;
     float scale = 1.0f;
     float rx;
     float ry;
     float rz;
}