import OpenGL.*;
class LightTest {

	public static void main( String args[] ) {
      LightTest lightTest = new LightTest();
	    lightTest.run();
	}

	public void run(){
    	OpenGLwidget gl = null;

    	/* try to instantiate an OpenGL widget */
    	try {
    		gl = new OpenGLwidget();
    	}
    	catch (Throwable e) {
    		e.printStackTrace();
    		System.out.println("can't open the OGL library");
    		// System.exit(-1);
    	}

    	gl.enable(gl.LIGHTING);
    	gl.enable(gl.LIGHT0);
    	gl.depthFunc(gl.LEQUAL);
    	gl.enable(gl.DEPTH_TEST);
      gl.enable(gl.CULL_FACE);

    	int w  = gl.getWidth();
    	int h = gl.getHeight();

    	gl.viewport(0,0,w, h);
    	gl.matrixMode(gl.PROJECTION);
    	gl.loadIdentity();
    	gl.perspective(40.0, (float) w / (float) h, 1.0, 20.0);
    	gl.matrixMode(gl.MODELVIEW);

    	double spin = 0.;
    	while ( ! gl.kbhit() ){
    	    float[] position = {0.f, 0.f, 1.5f, 1.f};
    	    gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT );
    	    gl.pushMatrix();
    	        gl.translate(0.,0.,-5.);
    	        gl.pushMatrix();
    	          gl.rotate(spin, 1., 0., 0.);
    	          gl.light(gl.LIGHT0, gl.POSITION, position);
    	          gl.translate(0.,0.,1.5);
    	          gl.disable(gl.LIGHTING);
    	          gl.color(0.7,1.,1.);
    	          gl.auxWireSphere(0.1);
    	          gl.enable(gl.LIGHTING);
    	        gl.popMatrix();

    	          gl.rotate(spin/.7, 0.,1., 0.);
    	    gl.auxSolidTorus(0.275, 0.85);
    	    // gl.auxSolidSphere(0.5);
    	    gl.popMatrix();
    	    gl.swap();
    	    spin += 1;
    	}
    }
}