/*
 * Leo Chan -- 1995
 *
 * This C file takes care of all the native implementation for the
 * OpenGL utility commands
 */

/*
 * need to include the JAVA internal header files for macros and function
 * prototypes required to maipulated JAVA data structures and functions
 *
 * StubPreamble.h includes the structure and macro definitions neede to
 * convert JAVA data structures into C data structures.
 *
 */

#include "StubPreamble.h"

/*
 * the next thing to include are special headers that were created by
 * JAVAH.  They include the C structure definitions for the JAVA classes
 */
#include "..\OpenGL\OpenGL_OpenGLwidget.h"

/*--------------------------------------------------------------------------
 * here on in is just regular apple pie C
 */

/*
 * next put any C UNIX specific header files that are necessary to implement
 * this native code
 */
/*
#include <GL/glu.h>
*/
/**
 * herein lies the native JAVA methods for the OpenGL functions.
 */

#include <GL/glu.h>
#include <GL/glaux.h>
//#include "OpenGL_open.h"


void OpenGL_OpenGLwidget_build2DMipmaps(struct HOpenGL_OpenGLwidget *this,
        long target, long components, long width, long height,
        long format, long type, HArrayOfByte * data, long offset)
{
	gluBuild2DMipmaps(target, components, width, height,
	    format, type, unhand(data)->body + offset);
}


void OpenGL_OpenGLwidget_lookAt(struct HOpenGL_OpenGLwidget *this,
        double eyex, double eyey, double eyez,
        double centerx, double centery, double centerz,
        double upx, double upy, double upz)
{
	gluLookAt(eyex, eyey, eyez, centerx, centery, centerz, upx, upy, upz );
}

void OpenGL_OpenGLwidget_perspective(struct HOpenGL_OpenGLwidget *this,
									double fov,
									double aspect,
									double near2,
									double far2)
{
   /* printf("perspective %g %g %g %g\n", fov, aspect, near2, far2); */
	gluPerspective((float) fov, (float)aspect, (float)near2, (float)far2 );
}

long OpenGL_OpenGLwidget_newQuadric(struct HOpenGL_OpenGLwidget * u){
	return (long) gluNewQuadric();
}

void OpenGL_OpenGLwidget_deleteQuadric(struct HOpenGL_OpenGLwidget * u,long a){
	gluDeleteQuadric((GLUquadricObj*) a);
}

void OpenGL_OpenGLwidget_quadricDrawStyle(struct HOpenGL_OpenGLwidget * u,long a,long b){
	gluQuadricDrawStyle((GLUquadricObj*) a, b);
}

void OpenGL_OpenGLwidget_quadricOrientation(struct HOpenGL_OpenGLwidget * u,long a,long b){
	gluQuadricOrientation((GLUquadricObj*) a, b);
}

void OpenGL_OpenGLwidget_quadricNormals(struct HOpenGL_OpenGLwidget * u,long a,long b){
	gluQuadricNormals((GLUquadricObj*) a, b);
}

void OpenGL_OpenGLwidget_quadricTexture(struct HOpenGL_OpenGLwidget * u,long a,/*boolean*/ long b){
	gluQuadricTexture((GLUquadricObj*) a, (unsigned char) b);
}

void OpenGL_OpenGLwidget_cylinder(struct HOpenGL_OpenGLwidget * u,long a, double b, double c, double d, long e, long f){
	gluCylinder((GLUquadricObj*) a, b, c, d, e, f);
}

void OpenGL_OpenGLwidget_sphere(struct HOpenGL_OpenGLwidget * u,long a, double b,long c,long d){
	gluSphere((GLUquadricObj*) a, b, c, d);
}

void OpenGL_OpenGLwidget_disk(struct HOpenGL_OpenGLwidget * u,long a,double b,double c,long d,long e){
	gluDisk((GLUquadricObj*) a, b, c, d, e);
}

void OpenGL_OpenGLwidget_partialDisk(struct HOpenGL_OpenGLwidget * u,long a,double b,double c,long d,long e,double f,double g){
	gluPartialDisk((GLUquadricObj*) a, b, c, d, e, f, g);
}

void OpenGL_OpenGLwidget_auxWireSphere(struct HOpenGL_OpenGLwidget * u,double a){
	auxWireSphere(a);
}
void OpenGL_OpenGLwidget_auxSolidSphere(struct HOpenGL_OpenGLwidget * u,double a){
	auxSolidSphere(a);
}
void OpenGL_OpenGLwidget_auxWireCube(struct HOpenGL_OpenGLwidget * u,double a){
	auxWireCube(a);
}
void OpenGL_OpenGLwidget_auxSolidCube(struct HOpenGL_OpenGLwidget * u,double a){
	auxSolidCube(a);
}
void OpenGL_OpenGLwidget_auxWireBox(struct HOpenGL_OpenGLwidget * u,double a,double b,double c){
	auxWireBox(a, b, c);
}
void OpenGL_OpenGLwidget_auxSolidBox(struct HOpenGL_OpenGLwidget * u,double a,double b,double c){
	auxSolidBox(a, b, c);
}
void OpenGL_OpenGLwidget_auxWireTorus(struct HOpenGL_OpenGLwidget * u,double a,double b){
	auxWireTorus(a, b);
}
void OpenGL_OpenGLwidget_auxSolidTorus(struct HOpenGL_OpenGLwidget * u,double a,double b){
	auxSolidTorus(a, b);
}
void OpenGL_OpenGLwidget_auxWireCylinder(struct HOpenGL_OpenGLwidget * u,double a,double b){
	auxWireCylinder(a, b);
}
void OpenGL_OpenGLwidget_auxSolidCylinder(struct HOpenGL_OpenGLwidget * u,double a,double b){
	auxSolidCylinder(a, b);
}
void OpenGL_OpenGLwidget_auxWireIcosahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxWireIcosahedron(a);
}
void OpenGL_OpenGLwidget_auxSolidIcosahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxSolidIcosahedron(a);
}
void OpenGL_OpenGLwidget_auxWireOctahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxWireOctahedron(a);
}
void OpenGL_OpenGLwidget_auxSolidOctahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxSolidOctahedron(a);
}
void OpenGL_OpenGLwidget_auxWireTetrahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxWireTetrahedron(a);
}
void OpenGL_OpenGLwidget_auxSolidTetrahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxSolidTetrahedron(a);
}
void OpenGL_OpenGLwidget_auxWireDodecahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxWireDodecahedron(a);
}
void OpenGL_OpenGLwidget_auxSolidDodecahedron(struct HOpenGL_OpenGLwidget * u,double a){
	auxSolidDodecahedron(a);
}
void OpenGL_OpenGLwidget_auxWireCone(struct HOpenGL_OpenGLwidget * u,double a,double b){
	auxWireCone(a, b);
}
void OpenGL_OpenGLwidget_auxSolidCone(struct HOpenGL_OpenGLwidget * u,double a,double b){
	auxSolidCone(a, b);
}
void OpenGL_OpenGLwidget_auxWireTeapot(struct HOpenGL_OpenGLwidget * u,double a){
	auxWireTeapot(a);
}
void OpenGL_OpenGLwidget_auxSolidTeapot(struct HOpenGL_OpenGLwidget * u,double a){
	auxSolidTeapot(a);
}
void OpenGL_OpenGLwidget_ortho2D(struct HOpenGL_OpenGLwidget * u,double a,double b,double c,double d){
	gluOrtho2D(a, b, c, d);
}

/* And GLUT functions, too */

#ifdef GLUT
#include <GL/glut.h>
static void* fontForID(int id){
	switch ( id ) {
	default:
	case 0: return GLUT_BITMAP_9_BY_15;
    case 1: return GLUT_BITMAP_8_BY_13;
	case 2: return GLUT_BITMAP_TIMES_ROMAN_10;
	case 3: return GLUT_BITMAP_TIMES_ROMAN_24;
	case 4: return GLUT_BITMAP_HELVETICA_10;
	case 5: return GLUT_BITMAP_HELVETICA_12;
    case 6: return GLUT_BITMAP_HELVETICA_18;
	}
}
#endif
void OpenGL_OpenGLwidget_glutBitmapCharacter(struct HOpenGL_OpenGLwidget * u,long a,long b){
#ifdef GLUT
	glutBitmapCharacter(fontForID(a), b);
#endif
}

long OpenGL_OpenGLwidget_glutBitmapWidth(struct HOpenGL_OpenGLwidget * u,long a,long b){
#ifdef GLUT
	return glutBitmapWidth(fontForID(a), b);
#else
	return 0;
#endif
}
