/*
 * Leo Chan -- 1995
 * lchan@cgl.uwaterloo.ca
 *
 * This mammoth C file takes care of all the native implementation for the
 * bulk of OpenGL commands
 */

/* 
 * need to include the JAVA internal header files for macros and function
 * prototypes required to maipulated JAVA data structures and functions
 *
 * StubPreamble.h includes the structure and macro definitions neede to
 * convert JAVA data structures into C data structures.
 *
 */

#include "StubPreamble.h"

/*
 * the next thing to include are special headers that were created by
 * JAVAH.  They include the C structure definitions for the JAVA classes
 */
#include "..\OpenGL\OpenGL_OpenGLwidget.h"

/*--------------------------------------------------------------------------
 * here on in is just regular apple pie C
 */

/*
 * next put any C UNIX specific header files that are necessary to implement
 * this native code
 */			

//#include <GL/glx.h>
#include <GL/gl.h>


void OpenGL_OpenGLwidget_texGenf(struct HOpenGL_OpenGLwidget *this,
									long coord,
									long pname,
									float param)
{
	GLenum gl_coord, gl_pname;
	GLfloat gl_param;

	switch( coord ) {
	case OpenGL_OpenGLwidget_S:
		gl_coord = GL_S;
		break;
	case OpenGL_OpenGLwidget_T:
		gl_coord = GL_T;
		break;
	case OpenGL_OpenGLwidget_R:
		gl_coord = GL_R;
		break;
	case OpenGL_OpenGLwidget_Q:
		gl_coord = GL_Q;
		break;
	default:
		return;
	}
	switch( pname ) {
	case OpenGL_OpenGLwidget_TEXTURE_GEN_MODE:
		gl_pname = GL_TEXTURE_GEN_MODE;
		break;
	default:
		return;
	}

	if( param == (float)OpenGL_OpenGLwidget_OBJECT_LINEAR)
		gl_param = (float) GL_OBJECT_LINEAR;
	else if( param == (float)OpenGL_OpenGLwidget_EYE_LINEAR )
		gl_param = (float) GL_EYE_LINEAR;
	else if( param == (float)OpenGL_OpenGLwidget_SPHERE_MAP )
		gl_param = (float) GL_SPHERE_MAP;
	else
		return;

	glTexGenf( gl_coord, gl_pname, gl_param );
}

void OpenGL_OpenGLwidget_texGeni(struct HOpenGL_OpenGLwidget *this,
									long coord,
									long pname,
									long param)
{
	GLenum gl_coord, gl_pname;
	GLint gl_param;

	switch( coord ) {
	case OpenGL_OpenGLwidget_S:
		gl_coord = GL_S;
		break;
	case OpenGL_OpenGLwidget_T:
		gl_coord = GL_T;
		break;
	case OpenGL_OpenGLwidget_R:
		gl_coord = GL_R;
		break;
	case OpenGL_OpenGLwidget_Q:
		gl_coord = GL_Q;
		break;
	default:
		return;
	}
	switch( pname ) {
	case OpenGL_OpenGLwidget_TEXTURE_GEN_MODE:
		gl_pname = GL_TEXTURE_GEN_MODE;
		break;
	default:
		return;
	}
	switch( param ) {
	case ((long)OpenGL_OpenGLwidget_OBJECT_LINEAR):
		gl_param = GL_OBJECT_LINEAR;
		break;
	case ((long)OpenGL_OpenGLwidget_EYE_LINEAR):
		gl_param = GL_EYE_LINEAR;
		break;
	case ((long)OpenGL_OpenGLwidget_SPHERE_MAP):
		gl_param = GL_SPHERE_MAP;
		break;
	default:
		return;
	}
	glTexGeni( gl_coord, gl_pname, gl_param );
}

/* TO DO: glTexImage1D, glTexParameter */

void OpenGL_OpenGLwidget_pixelStore(struct HOpenGL_OpenGLwidget * u,long a,long b){
	glPixelStorei(a, b);
}

void OpenGL_OpenGLwidget_texImage2D(struct HOpenGL_OpenGLwidget * this,
    long a,long b,long c,long d,long e,long f,long g,long h,HArrayOfByte * i,long j)
{
	glTexImage2D(a, b, c, d, e, f, g, h, & unhand(i)->body[j]);
}

void OpenGL_OpenGLwidget_translated(struct HOpenGL_OpenGLwidget *this,
									double x,
									double y,
									double z)
{
	glTranslated( x, y, z );
}

void OpenGL_OpenGLwidget_translatef(struct HOpenGL_OpenGLwidget *this,
									float x,
									float y,
									float z)
{
	glTranslatef( x, y, z );
}

void OpenGL_OpenGLwidget_vertex2d(struct HOpenGL_OpenGLwidget *this,
									double x,
									double y)
{
	glVertex2d( x, y );
}

void OpenGL_OpenGLwidget_vertex2f(struct HOpenGL_OpenGLwidget *this,
									float x,
									float y)
{
	glVertex2f( x,y );
}

void OpenGL_OpenGLwidget_vertex2i(struct HOpenGL_OpenGLwidget *this,
									long x,
									long y)
{
	glVertex2i( (GLint)x, (GLint)y );
}

void OpenGL_OpenGLwidget_vertex2s(struct HOpenGL_OpenGLwidget *this,
									short x,
									short y)
{
	glVertex2s( x,y );
}

void OpenGL_OpenGLwidget_vertex3d(struct HOpenGL_OpenGLwidget *this,
									double x,
									double y,
									double z)
{
	glVertex3d( x,y,z );
}

void OpenGL_OpenGLwidget_vertex3f(struct HOpenGL_OpenGLwidget *this,
									float x,
									float y,
									float z)
{
    glVertex3f( x,y,z );
}

void OpenGL_OpenGLwidget_vertex3i(struct HOpenGL_OpenGLwidget *this,
									long x,
									long y,
									long z)
{
	glVertex3i( (GLint) x, (GLint)y, (GLint)z );
}

void OpenGL_OpenGLwidget_vertex3s(struct HOpenGL_OpenGLwidget *this,
									short x,
									short y,
									short z)
{
	glVertex3s( x,y,z );
}

void OpenGL_OpenGLwidget_vertex4d(struct HOpenGL_OpenGLwidget *this,
									double x,
									double y,
									double z,
									double w)
{
	glVertex4d( x,y,z,w );
}

void OpenGL_OpenGLwidget_vertex4f(struct HOpenGL_OpenGLwidget *this,
									float x,
									float y,
									float z,
									float w)
{
	glVertex4f( x,y,z,w );
}

void OpenGL_OpenGLwidget_vertex4i(struct HOpenGL_OpenGLwidget *this,
									long x,
									long y,
									long z,
									long w)
{
	glVertex4i( (GLint)x, (GLint)y, (GLint)z, (GLint)w );
}

void OpenGL_OpenGLwidget_vertex4s(struct HOpenGL_OpenGLwidget *this,
									short x,
									short y,
									short z,
									short w)
{
	glVertex4s( x,y,z,w );
}
void OpenGL_OpenGLwidget_viewport(struct HOpenGL_OpenGLwidget *this,
									long x,
									long y,
									long width,
									long height)
{
	glViewport( (GLint)x, (GLint)y, (GLsizei)width, (GLsizei)height ); 
}

void OpenGL_OpenGLwidget_texParameterf(struct HOpenGL_OpenGLwidget *this, long target, long pname, float param )
{
    glTexParameterf( target, pname, param );
}

void OpenGL_OpenGLwidget_texParameteri(struct HOpenGL_OpenGLwidget *this, long target, long pname, long param )
{
    glTexParameteri( target, pname, param );
}

void OpenGL_OpenGLwidget_genTextures(struct HOpenGL_OpenGLwidget *this, long n, HArrayOfInt * textures )
{
    long i;
    GLuint* temp = (GLuint*) malloc(sizeof(GLuint)*n);
    if ( temp ) {
        glGenTextures( n, temp );
        for(i = 0; i < n; i++){
            /* printf("glGenTextures %d %d\n", i, temp[i]); */
            unhand(textures)->body[i] = temp[i];
        }
        free(temp);
    }
}

void OpenGL_OpenGLwidget_deleteTextures(struct HOpenGL_OpenGLwidget *this, long n, HArrayOfInt * textures )
{
    long i;
    GLuint* temp = (GLuint*) malloc(sizeof(GLuint)*n);
    if ( temp ) {
        for(i = 0; i < n; i++){
            temp[i] = (GLuint) unhand(textures)->body[i];
        }
        glDeleteTextures( n, temp );
        free(temp);
    }
}

void OpenGL_OpenGLwidget_bindTexture(struct HOpenGL_OpenGLwidget *this, long target, long texture )
{
    glBindTexture( target, texture );
}
