import OpenGL.*;

class Cube implements Drawable {
    private static float vdata[][] = {
        {0.f,0.f,0.f},
        {0.f,0.f,1.f},
        {0.f,1.f,0.f},
        {0.f,1.f,1.f},

        {1.f,0.f,0.f},
        {1.f,0.f,1.f},
        {1.f,1.f,0.f},
        {1.f,1.f,1.f}
    };

    private static int qindicies[][] = {
        {0,2,3,1},
        {2,6,7,3},
        {0,1,5,4},

        {1,3,7,5},
        {0,4,6,2},
        {4,5,7,6}
    };

    public void draw(OpenGLwidget gl){
        gl.pushMatrix();
        gl.translate(-0.5f,-0.5f,-0.5f);
        gl.begin(gl.QUADS);
        for(int i = 0; i < 6; i++){
            int[] indices = qindicies[i];
            float[] a = vdata[indices[0]];
            float[] b = vdata[indices[1]];
            float[] c = vdata[indices[2]];
            float[] d = vdata[indices[3]];
            GU.normal(gl, a, b, c);
            double texScale = 1.;
            gl.texCoord(0., 0.);
            GU.vertex(gl, a);
            gl.texCoord(0., texScale);
            GU.vertex(gl, b);
            gl.texCoord(texScale, texScale);
            GU.vertex(gl, c);
            gl.texCoord(texScale, 0.);
            GU.vertex(gl, d);
        }
        gl.end();
        gl.popMatrix();
    }

    public void getBounds(Rect3D  rect){
        rect.x0 = 0.;
        rect.y0 = 0.;
        rect.z0 = 0.;
        rect.x1 = 1.;
        rect.y1 = 1.;
        rect.z1 = 1.;
    }
}