import OpenGL.*;

class Sphere implements Drawable {
    DisplayList base;
    public Sphere(OpenGLwidget gl, float radius, int slices, int stacks){
      base = new DisplayList(gl);
      gl.newList(base, gl.COMPILE);
      int quadObj = gl.newQuadric();
    	gl.quadricDrawStyle(quadObj, gl.GLU_FILL);
    	gl.quadricNormals(quadObj, gl.GLU_SMOOTH);
    	// gl.quadricOrientation(quadObj, gl.GLU_OUTSIDE);
    	gl.quadricTexture(quadObj, true);
    	gl.sphere(quadObj, radius, slices, stacks);
    	gl.deleteQuadric(quadObj);
      gl.endList();
    }
    public void draw(OpenGLwidget gl){
      gl.callList(base.list);
    }
}