import OpenGL.*;

class Texture {

	public static void main( String args[] ) {
	    try {
	      Texture texture = new Texture();
	      texture.run();
	    } catch (Throwable t){
	      t.printStackTrace();
	    }
	    System.exit(0);
	}

	public void run(){
    	OpenGLwidget gl = null;

    	/* try to instantiate an OpenGL widget */
    		gl = new OpenGLwidget( "My Widget" );
    	try {
        	main2(gl);
    	}
    	finally {
    	    gl.shutdown();
    	}
    }
    void main2(OpenGLwidget gl){
    	gl.clearColor( 0.8f, 0.8f, 1.0f, 1.0f );
    	gl.frontFace( gl.CW );
    	gl.enable( gl.DEPTH_TEST );

    	int width  = gl.getWidth();
    	int height = gl.getHeight();

    	gl.viewport( 0, 0, width, height );

    	System.err.println("after viewPort");
    	gl.matrixMode( gl.PROJECTION );
    	gl.loadIdentity();

    	double fov    = 60.0,
    		   aspect = width / height,
    		   near   = 1.0,
    		   far    = 300.0;
        float size = 10;
        float z = 5;
    	gl.perspective( fov, aspect, near, far );

        gl.enable(gl.DEPTH_TEST);
        gl.depthFunc(gl.LESS);
        gl.shadeModel(gl.SMOOTH);

        gl.translate(0.0f, 0.0f, -3.6f);
        gl.matrixMode(gl.MODELVIEW);
        gl.hint(gl.PERSPECTIVE_CORRECTION_HINT, gl.NICEST);
        gl.enable(gl.TEXTURE_2D);

        createTexture(gl);

    	for(int i = 1; i < 4000; i++ ) {
    	    System.err.println(i);
    	    if ( gl.kbhit() ){
    	        break;
    	    }
    	    gl.clearColor(0.f,0.f,(float)(i % 256)/255.f, 1.f);
            gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
            gl.enable(gl.TEXTURE_2D);
            gl.pushMatrix();
            	gl.translate(0.0f, 0.0f, -(100 +i));
            	gl.rotate(i,0,0,1);
            	//gl.rotate(i,0,1,0);
            	//gl.rotate(i,1,0,0);
            	//gl.translate(0.0f, 0.0f, eyez);
                // gl.begin(gl.TRIANGLE_STRIP);
                gl.begin(gl.QUADS);
                    gl.texCoord( -1,-1);
                    gl.color(1.,1.,1.);
                    gl.vertex(-size, -size, z);
                    gl.texCoord( -1,1);
                    gl.color(1.,0,0);
                    gl.vertex(-size, size, z);
                    gl.texCoord( 1,1);
                    gl.color(0,1.,0);
                    gl.vertex(size, size, z);
                    gl.color(0,0,1.);
                    gl.texCoord( 1, -1);
                    gl.vertex(size, -size, z);
                gl.end();

            gl.popMatrix();
            gl.finish();
        	gl.swap();
        	gl.flush();
    	}
	}


	static void createTexture(OpenGLwidget gl){
	    int w = 64;
	    byte[] texture = new byte[4*w*w];
	    int index = 0;
	    for(int y = 0; y < w; y++){
	        for(int x = 0; x < w; x++){
	            texture[index++] = (byte) (255 * x / (w-1));
	            texture[index++] = (byte) (255 * y / (w-1));
	            texture[index++] = (byte) 0;
	            texture[index++] = (byte) 255;
	        }
	    }
	    gl.bindTexture(gl.TEXTURE_2D, 0);
	    gl.build2DMipmaps(gl.TEXTURE_2D, 4, w, w, gl.RGBA, gl.GL_UNSIGNED_BYTE,
	        texture, 0);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER,
    		gl.LINEAR_MIPMAP_NEAREST);
        gl.texEnv(gl.TEXTURE_ENV, gl.TEXTURE_ENV_MODE,
            gl.MODULATE /* DECAL */);
	}
}