import OpenGL.*;
import java.util.*;

class Textures {

	public static void main( String args[] ) {
      Textures textures = new Textures();
	    textures.run();
	}

	public Textures(){
	}

	public void run(){
    	OpenGLwidget gl = null;

    	/* try to instantiate an OpenGL widget */
    	try {
    		gl = new OpenGLwidget();
    	}
    	catch (Throwable e) {
    		e.printStackTrace();
    		System.out.println("can't open the OGL library");
    		// System.exit(-1);
    	}
    	try {
        	main2(gl);
    	}
    	catch (Throwable e) {
    	  e.printStackTrace();
    	}
    	finally {
    	    gl.shutdown();
    	}
    }
    void main2(OpenGLwidget gl){
    	gl.clearColor( 0.8f, 0.8f, 1.0f, 1.0f );
    	// gl.frontFace( gl.CCW );
    	gl.enable( gl.DEPTH_TEST );
    	gl.clearColor(0.5f,0.5f,0.5f,1.0f);

    	int width  = gl.getWidth();
    	int height = gl.getHeight();
    	int i = 0;
    	boolean help = true;


    	double fov    = 60.0,
    		   aspect = (double) width / (double) height,
    		   near   = 1.0,
    		   far    = 3000.0;
       // setLight(gl);

    	//gl.enable(gl.FOG);
    	//gl.fog(gl.FOG_HINT, gl.NICEST);
    	//gl.fogColor(.5f,.5f,.5f,1.0f);

        gl.enable(gl.DEPTH_TEST);
        gl.enable(gl.CULL_FACE);
        gl.depthFunc(gl.LESS);
        gl.shadeModel(gl.SMOOTH);

        gl.hint(gl.PERSPECTIVE_CORRECTION_HINT, gl.NICEST);

        gl.enable(gl.TEXTURE_2D);
        int[] textureid = new int[3];
        gl.genTextures(textureid.length, textureid);
        createTexture(gl, textureid[0], "cloud.tga");
        createTexture(gl, textureid[1], "coins.tga");
        createTexture(gl, textureid[2], "RedMarb2.tga");
        float eyez = -100;
        int n = 1;

        long start = System.currentTimeMillis();
        boolean increment = true;
        boolean go = true;
        BirdBody birdBody = new BirdBody(textureid[0]);
        BirdSoul birdSoul = new BirdSoul(birdBody);
        birdSoul.phase = 1;
        Vector actors = new Vector();
        actors.addElement(birdSoul);
        actors.addElement(new BirdSoul(new BirdBody(textureid[1])));
        actors.addElement(new BirdSoul(new BirdBody(textureid[2]), 2));
        actors.addElement(new GroundSoul(new Ground(textureid[2])));
        actors.addElement(new BirdSoul2(new BirdBody2(textureid[0])));
        actors.addElement(new BirdSoul(new BirdBody4(textureid[0],
          new Teapot(gl))));
        actors.addElement(new BirdSoul(new BirdBody3(gl, textureid[2], 1.f, 2.f)));
    	  //int oldTime = 0;
    	  //double averageDelta = 0.;
    	  int oldFrames = 0;
    	  double dex = 0.;
    	  double dey = 0;
    	  double dez = 0;
    	  double dcx = 0;
    	  double dcy = 0;
    	  double dcz = 0;
    	  double d = .1;

    	  while(go){
        	gl.matrixMode( gl.PROJECTION );
        	gl.loadIdentity();
        	gl.perspective( fov, aspect, near, far );
        	gl.matrixMode( gl.MODELVIEW );
        	gl.loadIdentity();
        	gl.lookAt(ex, ey, ez, cx, cy, cz, 0.,1.,0.);
    	    //go = false;
    	    //System.err.println(i);
    	    if ( gl.kbhit() ){
    	        char c = (char) gl.getch();
    	        // System.err.println("Key is: '" + c +"'");
    	        switch ( c) {
    	            case '1': dcx += d; break;
    	            case '!': dcx -= d; break;
    	            case '2': dcy += d; break;
    	            case '@': dcy -= d; break;
    	            case '3': dcz += d; break;
    	            case '#': dcz -= d; break;

    	            case '4': dex += d; break;
    	            case '$': dex -= d; break;
    	            case '5': dey += d; break;
    	            case '%': dey -= d; break;
    	            case '6': dez += d; break;
    	            case '^': dez -= d; break;
    	            case 'q':
    	                go = false;
    	                break;
    	            case 'h':
    	              help = ! help;
    	            case 'w':
    	              gl.enable(gl.LIGHT0);
    	              break;

    	            case 'W':
    	              gl.disable(gl.LIGHT0);
    	              break;
    	            case '+':
    	                n++;
    	                float f = (float) n;
                      float[] lightDiffuse = {f,f,f,1.f};
                      gl.light(gl.LIGHT0, gl.DIFFUSE, lightDiffuse);
    	                break;
    	            case '-':
    	                n = Math.max(1,n-1);
    	                break;
    	            case ' ':
    	                increment = ! increment;
    	                break;
    	        }
    	    }
    	      cx += dcx;
    	      cy += dcy;
    	      cz += dcz;
    	      ex += dex;
    	      ey += dey;
    	      ez += dez;
            gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
            //gl.texGen(gl.S,gl.TEXTURE_GEN_MODE,gl.OBJECT_LINEAR);
            //gl.texGen(gl.T,gl.TEXTURE_GEN_MODE,gl.OBJECT_LINEAR);
            gl.pushMatrix();
            	gl.translate(0.0f, 0.0f, eyez);

            	int time = (int) (System.currentTimeMillis() - start);
            	//int delta = time - oldTime;
            	//if ( delta < 10 ) {
            	//  time += averageDelta;
            	//}
            	//averageDelta = (averageDelta * 4 + delta) / 5;
            	//System.err.println(averageDelta );
            	//oldTime = time;
            	double millsPerFrame = (1000/60.);
            	int frames = (int) (time / millsPerFrame);
            	if ( frames <= oldFrames ) {
            	  frames = oldFrames + 1;
            	}
            	frames = oldFrames + 1;
            	// System.err.print(frames - oldFrames);
            	time = (int) (frames * millsPerFrame);
            	oldFrames = frames;

            	for(int i2 = 0; i2 <actors.size(); i2++){
            	    Soul soul = (Soul) actors.elementAt(i2);
            	    soul.timeIs(time);
            	    soul.getBody().draw(gl);
            	}

            gl.popMatrix();

          if ( help ) printHelp(gl);
        	gl.swap();
        	gl.flush();
          // System.err.println(gl.bufferNumPending());
          //while ( gl.bufferNumPending() > 1 ){
          //  Thread.yield();
          //}
    	}
	}

  void printHelp(OpenGLwidget gl)
  {
 	  gl.disable(gl.TEXTURE_2D);
    gl.disable(gl.DEPTH_TEST);
	  gl.shadeModel(gl.FLAT);

 	  gl.matrixMode(gl.PROJECTION);
  	gl.pushMatrix();
  	gl.loadIdentity();
  	gl.ortho(-0.5,639.5,-0.5,479.5,-1.0,1.0);
  	gl.matrixMode(gl.MODELVIEW);
  	gl.pushMatrix();
  	gl.loadIdentity();
  	gl.enable(gl.BLEND);
  	gl.blendFunc(gl.SRC_ALPHA,gl.ONE_MINUS_SRC_ALPHA);
  	gl.color(0.0,0.0,0.0,0.3);
  	gl.rect(40,40,600,440);
  	gl.disable(gl.BLEND);

  	gl.color(1.0,0.0,0.0);
  	gl.rasterPos(300,420);
  	gl.glutBitmapString(gl.GLUT_BITMAP_TIMES_ROMAN_24,"Help");
  	gl.rasterPos(270,420-30);
  	gl.glutBitmapString(gl.GLUT_BITMAP_TIMES_ROMAN_24,"q - Quit");
  	gl.rasterPos(270,420-60);
  	gl.glutBitmapString(gl.GLUT_BITMAP_TIMES_ROMAN_24,"h - Toggle Help");
  	gl.color(0.7,1.0,0.7);
  	gl.rasterPos(50,50);
  	gl.glutBitmapString(gl.GLUT_BITMAP_TIMES_ROMAN_10,
  	  "center " + cx + " " + cy + " " + cz
  	  + " eye " + ex + " " + ey + " " + ez);
  	gl.color(1.0,1.0,1.0);
  	gl.popMatrix();
  	gl.matrixMode(gl.PROJECTION);
  	gl.popMatrix();
  	gl.matrixMode(gl.MODELVIEW);

 	  gl.enable(gl.TEXTURE_2D);
    gl.enable(gl.DEPTH_TEST);
	  gl.shadeModel(gl.SMOOTH);
  }


	/*
{
        	if ( increment ) {
        	    long now = ;
        	    int frames = (int) (((int)(now - start)) / (1000/60.));
        	    int delta = frames - i;
        	    if ( delta <= 0 ){
        	        delta = 1;
        	    }
       	        //System.err.println(delta);
        	    i += delta;
        	}
                	//gl.rotate(i,0,0,1);
            	gl.rotate(i,0,1,0);
            	// gl.rotate(i,1,0,0);
            	double scale = (size / ((n*1.5 - .5)));
                // gl.translate(-0.5, -0.5, -0.5);
            	gl.scale(scale, scale, scale);
            	for(int x = 0; x < n; x++){
                	for(int y = 0; y < n; y++){
                    	for(int z = 0; z < n; z++){
                    	    int t = (x+y+z) %textureid.length;
                    	    // System.err.println(t);
                    	    gl.bindTexture(gl.TEXTURE_2D, textureid[t]);
                    	    gl.pushMatrix();
                    	    gl.translate(1.5 * x, 1.5 * y, 1.5 * z);
                    	    switch ( t % 3 ){
                    	        case 0: gl.rotate(i,1,0,0); break;
                    	        case 1: gl.rotate(-2*i,0,1,0); break;
                    	        case 2: gl.rotate(i,0,0,1); break;
                    	    }
                    	    bird.draw(gl);
                    	    gl.popMatrix();
                    	}
                    }
            	}
}
*/
    void setLight(OpenGLwidget gl){
        float[] matDiffuse = {.6f,.6f,.6f,1.f};
        float[] matSpecular = {1.f,1.f,1.f,1.f};
        float[] matShininess = {50.f};
        float[] lightPosition ={0.f, 0.f, 2.f, 0.f};
        float[] lightAmbient = {.2f, .2f, .2f, 1.f};
        float[] lightDiffuse = {.6f, .6f, .6f, 1.f};
        // gl.shadeModel(gl.SMOOTH);
    	  gl.enable( gl.LIGHTING);
    	  gl.enable( gl.LIGHT0);
        // gl.light(gl.LIGHT0, gl.POSITION, lightPosition);
        gl.light(gl.LIGHT0, gl.AMBIENT, lightDiffuse);
        //gl.light(gl.LIGHT0, gl.DIFFUSE, lightDiffuse);
        // gl.light(gl.LIGHT0, gl.POSITION, lightPosition);

        gl.material(gl.FRONT_AND_BACK, gl.DIFFUSE, matDiffuse);
        gl.material(gl.FRONT_AND_BACK, gl.SPECULAR, matSpecular);
        gl.material(gl.FRONT_AND_BACK, gl.SHININESS, matShininess);
    }

	static void createTexture(OpenGLwidget gl, int texid, String fileName){
	    gl.bindTexture(gl.TEXTURE_2D, texid);
	    TGAFile tga = new TGAFile(fileName, 128,128);
	    gl.build2DMipmaps(gl.TEXTURE_2D, 4, tga.width(), tga.height(), gl.RGBA, gl.GL_UNSIGNED_BYTE,
	        tga.getData(), 0);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
        gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_NEAREST);
        gl.texEnv(gl.TEXTURE_ENV, gl.TEXTURE_ENV_MODE,
            gl.MODULATE);
	}

    	  double ex = 0.;
    	  double ey = 0.;
    	  double ez = 0;
    	  double cx = 0;
    	  double cy = 0;
    	  double cz = -10;

}
