import OpenGL.*;
import java.util.*;

class Textures2 {

	public static void main( String args[] ) {
      Textures2 textures = new Textures2();
	    textures.run();
	}

	public Textures2(){
	}

	public void run(){
    	OpenGLwidget gl = null;

    	/* try to instantiate an OpenGL widget */
    	try {
    		gl = new OpenGLwidget();
    	}
    	catch (Throwable e) {
    		e.printStackTrace();
    		System.out.println("can't open the OGL library");
    		// System.exit(-1);
    	}
    	try {
        	main2(gl);
    	}
    	catch (Throwable e) {
    	  e.printStackTrace();
    	}
    	finally {
    	    gl.shutdown();
    	}
    }
    void main2(OpenGLwidget gl){
      gl.clearDepth(1.0);
      gl.depthFunc(gl.LEQUAL);
      gl.enable(gl.DEPTH_TEST);
      gl.depthFunc(gl.LESS);
      gl.enable(gl.CULL_FACE);
	    gl.cullFace(gl.FRONT);
      gl.enable(gl.TEXTURE_2D);

      gl.clearColor(0.0f,0.f,0.f,1.f);
      gl.hint(gl.PERSPECTIVE_CORRECTION_HINT, gl.NICEST);

    	int width  = gl.getWidth();
    	int height = gl.getHeight();
    	int i = 0;
    	boolean help = true;


    	double fov    = 60.0,
    		   aspect = (double) width / (double) height,
    		   near   = 1.0,
    		   far    = 3000.0;

        int[] textureid = new int[1];
        GU.genTextures(gl, textureid);

        createTexture(gl, textureid[0], "cloud.tga");
        //createTexture(gl, textureid[1], "coins.tga");
        //createTexture(gl, textureid[2], "RedMarb2.tga");
        float eyez = -10;
        int n = 1;

        long start = System.currentTimeMillis();
        boolean increment = true;
        boolean go = true;
        BirdBody birdBody = new BirdBody(textureid[0]);
        BirdSoul birdSoul = new BirdSoul(birdBody);
        birdSoul.phase = 1;
        birdBody.scale = 2;
        Vector actors = new Vector();
        actors.addElement(birdSoul);
    	  //int oldTime = 0;
    	  //double averageDelta = 0.;
    	  int oldFrames = 0;
    	  double d = .1;

    	  gl.setRawKeyMode(true);

        char c = 0;
        boolean down = false;
    	  while(go){
        	gl.matrixMode( gl.PROJECTION );
        	gl.loadIdentity();
        	gl.perspective( fov, aspect, near, far );
        	gl.matrixMode( gl.MODELVIEW );
        	gl.loadIdentity();
        	gl.lookAt(ex, ey, ez, cx, cy, cz, 0.,1.,0.);
        	gl.clearColor(1.0f,1.0f,1.0f,1.0f);
    	    if ( gl.kbhit() ){
    	        int code = gl.getch();
    	        down = (code & (1 << 31)) == 0;
    	        c = (char) (code & 0xff);
    	    }

    	    if ( down ) {
    	        switch ( c ) {
    	            case '1': cx += d; break;
    	            case '2': cx -= d; break;
    	            case '3': cy += d; break;
    	            case '4': cy -= d; break;
    	            case '5': cz += d; break;
    	            case '6': cz -= d; break;

    	            case '7': ex += d; break;
    	            case '8': ex -= d; break;
    	            case '9': ey += d; break;
    	            case '0': ey -= d; break;
    	            case '-': ez += d; break;
    	            case '=': ez -= d; break;
    	            case 'Q':
    	            case 27:
    	                go = false;
    	                break;
    	            case ' ':
    	                increment = ! increment;
    	                break;
    	        }
    	    }
            gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
            gl.pushMatrix();
            	gl.translate(0.0f, 0.0f, eyez);

            	int time = (int) (System.currentTimeMillis() - start);
            	double millsPerFrame = (1000/60.);
            	int frames = (int) (time / millsPerFrame);
            	if ( frames <= oldFrames ) {
            	  frames = oldFrames + 1;
            	}
            	frames = oldFrames + 1;
            	time = (int) (frames * millsPerFrame);
            	oldFrames = frames;

            	for(int i2 = 0; i2 <actors.size(); i2++){
            	    Soul soul = (Soul) actors.elementAt(i2);
            	    soul.timeIs(time);
            	    soul.getBody().draw(gl);
            	}

            gl.popMatrix();

        	gl.swap();
        	gl.flush();
    	}
	}

	static void createTexture(OpenGLwidget gl, int texid, String fileName){
	    TGAFile tga = new TGAFile(fileName, 128,128);
	    gl.bindTexture(gl.TEXTURE_2D, texid);
	    GU.build2DMipmaps(gl, gl.TEXTURE_2D, 4, tga.width(), tga.height(), gl.RGBA, gl.GL_UNSIGNED_BYTE,
	        tga.getData(), 0);
      gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
      gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
      gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
      gl.texParameter(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_NEAREST);
      gl.texEnv(gl.TEXTURE_ENV, gl.TEXTURE_ENV_MODE,
          gl.MODULATE);
	}

    	  double ex = 0.;
    	  double ey = 0.;
    	  double ez = 0.;
    	  double cx = 0.;
    	  double cy = 0.;
    	  double cz = -10.;

}
